diff a/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Rearrange.template b/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Rearrange.template
--- /dev/null
+++ b/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Rearrange.template
@@ -0,0 +1,42 @@
+
+    void rearrangeShared(int window, Blackhole bh) {
+        $type$[] as = fa.apply(size);
+        int[] order = fs.apply(size);
+        $type$[] rs = fr.apply(size);
+
+        for (int ic = 0; ic < INVOC_COUNT; ic++) {
+            for (int i = 0; i < as.length; i += window) {
+                for (int j = 0; j < window; j++) {
+                    $type$ a = as[i+j];
+                    int pos = order[j];
+                    rs[i + pos] = a;
+                }
+            }
+        }
+
+        bh.consume(rs);
+    }
+
+    @Benchmark
+    public void rearrange064(Blackhole bh) {
+        int window = 64 / $Wideboxtype$.SIZE;
+        rearrangeShared(window, bh);
+    }
+
+    @Benchmark
+    public void rearrange128(Blackhole bh) {
+        int window = 128 / $Wideboxtype$.SIZE;
+        rearrangeShared(window, bh);
+    }
+
+    @Benchmark
+    public void rearrange256(Blackhole bh) {
+        int window = 256 / $Wideboxtype$.SIZE;
+        rearrangeShared(window, bh);
+    }
+
+    @Benchmark
+    public void rearrange512(Blackhole bh) {
+        int window = 512 / $Wideboxtype$.SIZE;
+        rearrangeShared(window, bh);
+    }
